include lib
;-----------------------------------------------------------------------------
;DEL
;-----------------------------------------------------------------------------
;DEL(ete) lscht Dateien, keine Verzeichnisse! 
del:		push	   #cwd			;Cwd suchen
		sys	   #10			;SEARCH_ENV
		inc	   sp
		move mi	   #111,d0		;Falls keine CWD existiert Fehler
		jmi	   .fehler
		move	   d0,cwd_zeiger

;CmdLine suchen
		push	   #cmd
		sys	   #10			;SEARCH_ENV
		inc	   sp
		move	   d0,CmdLine		;CmdLine:Zeiger auf String

;Pufferzeiger initialisieren
		move	   #puffer,Pfad
		add	   #256,#puffer,lesepuffer

;Pfad bestimmen
		cmp	   (CmdLine),#$2f	;Ist Pfad mit angegeben?
		jeq	   .explizit
.cwd:		cmp	   (cwd_zeiger),-
		move ne    (cwd_zeiger),(pfad)	;Cwd kopieren
		inc  ne	   cwd_zeiger
		inc  ne	   pfad
		jne	   .cwd

.explizit:	cmp	   (CmdLine),-		;" "=Abbruch, an gegebenen Pfad kopieren
		move 	   (CmdLine),(pfad)
		inc  ne	   CmdLine
		inc  ne	   pfad
		jne	   .explizit		

;Suchstring und Quelverzeichnis isolieren
		move	   CmdLine,such_strg
.cut:		cmp	   (pfad),#$2f
		clr  	   (pfad)
		dec ne 	   pfad			;pfad:letzte position der Quelle
		dec ne	   such_strg
		jne	   .cut
		inc	   such_strg
		
;Quellverzeichnis zum Lesen ffnen
		push	   -			;zum lesen ffnen
		push	   #puffer		;Dateipfad 
		sys	   #12			;OPEN
		add	   #2,sp
		jmi	   .fehler
		move	   d0,Quell_fdb		;Quell_fdb: FDB-Adresse

;Ist ein Suchstring mit angegeben? Falls nein, selber einen * einsetzen
		cmp	   CmdLine,such_strg	;Ist Suchstring mit angegeben?
		add  eq	   #puffer,#264,d0	;Wenn nicht, * einsetzen
		move eq	   d0,such_strg
		move eq	   #$2a,(d0)
		inc  eq	   d0
		clr  eq    (d0)
		
		cmp	   (such_strg),#$2a	;Ist * unser Suchstring?
		jne	   .ok			;Nein, weiter machen

;Falls alle Dateien gelscht werden sollen Warnmeldung ausgeben
		move	   #warnung,d0
		jsr	   .stringout
		jmi	   .fehler
		
;Zeichen von StandardIn einlesen
.getloop:	push	   -			;Ein Zeichen einlesen, j=ok
		dec	   sp
		pushz
		sys	   #13			;READ
		add	   #3,sp
		jmi	   .getloop
		move	   d0,help

;Dieses Zeichen wieder ausgeben
		push	   -			;Zeichen ausgeben
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		jmi	   .fehler

;Falls diese Zeichen ein "j" oder "J" war weiter, sonst Abbruch
		and	   #$ff,help		;Nur Zeichencode betrachten
		cmp	   help,#$4a		;J?
		jeq	   .ok			;ja
		cmp	   help,#$6a		;j?
		jne	   .ende		;auch nicht!, ende

;Suchstring vorbereiten
.ok:		push	   Quell_fdb
		push	   lesepuffer		;Pufferadresse
		push	   such_strg		;Zeiger auf Namen
		sys	   #26			;PREPARE_SEARCH
		add	   #3,sp
		jmi	   .fehler

;Linefeed ausgeben
		move	   #lf,d0
		jsr	   .stringout
		jmi	   .fehler

		add	   #8,lesepuffer,datei_info	;datei_info:Lesepuffer
.searchread:	add	   #16,lesepuffer,Dateiname	;Dateiname:Zeiger auf Dateinamen

;Abbruchkommando  (CTRL-C) berprfen
		push	   -		;EinZeichen von StIn lesen
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		and	sf #$ff,d0	;Nur ASCCI-Code interessiert
		cmp	   d0,#3	;CTRL-C =Abbruch
		jeq	   .abbruch

;Nchste passende Datei suchen
		push	   lesepuffer		;Zeiger auf Suchstring
		push	   Quell_fdb		;FDB-Adresse
		sys	   #27			;SEARCH_NEXT
		add	   #2,sp
		jmi	   .ende		;Falls keinen gefunden -> Ende			

;Verzeichniseintrag lesen
		push	   #16			;16 Wrter
 		push	   datei_info		;Lesepuffer
		push	   Quell_fdb		;FDB-Adresse 
		sys	   #13			;READ
		add	   #3,sp

;gefundenen Namen an Pfad anhngen
		move	   #8,count			;Zhler
		move	   pfad,help
		move	   #$2f,(help)			;"/" anfgen
		inc	   help
.copy:		bswp	   (Dateiname),-,(help)		;High-Byte kopieren
		inc	   help
		and	   #$ff,(Dateiname),(help)	;Low-Byte kopieren
		inc	   help
		inc	   Dateiname
		dec	sf count			;Schon 16 Bytes kopiert?
		jne	   .copy			;Nein weitermachen
		clr	   (help)			;Stringendezeichen anfgen

;kompletten Pfadnamen ausgeben
		move	   #puffer,d0
		jsr	   .stringout
		jmi	   .fehler

;Gefundene Datei zum Schreiben ffnen um Writeprotect und Zugriffkonflikt festzustellen
		push	   #2			;Zum Schreiben ffnen
		push	   #puffer
		sys	   #12			;OPEN
		add	   #2,sp		
		jpl	   .dateiok		;Kein Fehler, ->weiter
		cmp	   d0,#114		;Writeprotect?
		jne	   .fehler		;Nein anderer Fehler

;Fehlerstring ausgeben
		move	   #wp_fehler,d0
		jsr	   .stringout
		jmi	   .fehler
		jmp	   .close		;Danach Datei wieder schlieen

;Handelt es sich bei dieser Datei um ein Verzeichnis?
.dateiok:	move	   d0,datei_fdb
		add	   #15,d0
		and	sf -,(d0),-		;Handelt es sich um eine Directory?
		jne	   .dir			;ja, Fehlerstring ausgeben

;Datei lschen
		push	   datei_fdb
		sys	   #21			;DELETE
		inc	   sp
		jmi	   .fehler

;Erfolgsmeldung ausgeben
		move	   #meldung,d0
		jsr	   .stringout
		jmi	   .fehler

;Datei schlieen, um FDB freizugeben
.close:		push	   datei_fdb
		sys	   #15			;Gefundene Datei wieder schlieen
		inc	   sp

		jmp	   .searchread		;Nchste Datei suchen

;Fehlerstring ausgeben
.dir:		move	   #dir_fehler,d0
		jsr	   .stringout
		jmi	   .fehler
		jmp	   .close		

.fehler:	push       d0
		sys	   #29			;Fehlerausgabe aufrufen
		push	   datei_fdb
		sys	   #15			;CLOSE, Datei schlieen
		add	   #2,sp

.ende:		push	   Quell_fdb
		sys	   #15			;CLOSE, Verzeichnis schlieen
		inc	   sp

;Linefeed ausgeben
		move	   #lf,d0
		jsr	   .stringout
		rts

;Abruchmeldung ausgeben
.abbruch:	move	   #break,d0
		jsr	   .stringout
		jmp	   .ende		

;String an StandardOut ausgeben
.stringout:	pushz				;String ausgeben
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		rts


cmd:		dw "cmd="
cwd:		dw "cwd="
cwd_zeiger:	dw 0	;Zeiger auf CWD
pfad:		dw 0	;Zeiger auf Dateipfad (256 Worte Puffer)
CmdLine:	dw 0	;Zeiger in der CmdLine
lesepuffer:	dw 0	;Zeiger auf Suchstring
datei_info:	dw 0	;Zeiger auf Verzeichniseintrag im Puffer (16 Worte)
Dateiname:	dw 0	;Zeiger auf Dateinamen in Verzwichniseintrag
such_strg:	dw 0	;Zeiger auf Suchstring
quell_fdb:	dw 0	;FDB-Adresse des Verzeichnisses
datei_fdb:	dw 0	;FDB-Adresse der zu lschenden Datei
count:		dw 0	;Zhler
help:		dw 0	;Hilfsvariable
lf:		dw 13,10,0
meldung:	dw " entfernt.",13,10,0
dir_fehler:	dw " ist Verzeichnis und kann nicht entfernt werden!",13,10,0
wp_fehler:	dw " ist schreibgeschtzt!",13,10,0
warnung:	dw 13,10,"Alle Dateien lschen? (j/n) ",0
break: 		dw 13,10,"Befehlsunterbrechung.",13,10,0
data
puffer: 280+128		;Puffer und Stackbereich
