include lib
;-----------------------------------------------------------------------------
;DIR
;-----------------------------------------------------------------------------
;DIR(ectory) zeigt den Inhalt ein angegeben Verzeichnisses an. 
dir:		push	   #cwd			;Cwd suchen
		sys	   #10			;SEARCH_ENV
		inc	   sp
		move mi	   #111,d0
		jmi	   .fehler
		move	   d0,cwd_zeiger

;CmdLine suchen
		push	   #cmd
		sys	   #10			;SEARCH_ENV
		inc	   sp
		move	   d0,CmdLine		;CmdLine: Zeiger auf String
	
;Pufferzeiger initialisieren
		move	   #puffer,Pfad
		add	   #256,#puffer,lesepuffer

;Verzeichnispfad ermitteln
		cmp	   (CmdLine),#$2f	;Ist Pfad mit angegeben?
		jeq	   .explizit
.cwd:		cmp	   (cwd_zeiger),-
		move ne    (cwd_zeiger),(pfad)	;Cwd kopieren
		inc  ne	   cwd_zeiger
		inc  ne	   pfad
		jne	   .cwd

.explizit:	cmp	   (CmdLine),-		;" "=Abbruch
		move 	   (CmdLine),(pfad)
		inc  ne	   CmdLine
		inc  ne	   pfad
		jne	   .explizit		

;Suchstring isolieren
		move	   CmdLine,such_strg
.cut:		cmp	   (pfad),#$2f
		clr  	   (pfad)
		dec ne 	   pfad			;pfad:letzte position der Quelle
		dec ne	   such_strg
		jne	   .cut
		inc  	   such_strg
		
;Verzeichnis zum Lesen ffnen
		push	   -			;zum lesen ffnen
		push	   #puffer		;Dateipfad 
		sys	   #12			;OPEN
		add	   #2,sp
		jmi	   .fehler
		move	   d0,Quell_fdb		;Quell_fdb: FDB-Adresse

;Ist ein Suchstring mit angegeben, falls nein "*" einsetzen
		cmp	   CmdLine,such_strg	;Ist Suchstring mit angegeben
		add  eq	   #puffer,#264,d0
		move eq	   d0,such_strg
		move eq	   #$2a,(d0)
		inc  eq	   d0
		clr  eq    (d0)
		
;Suchstring vorbereiten fr SEARCH_NEXT
		push	   Quell_fdb
		push	   lesepuffer		;Pufferadresse
		push	   such_strg		;Zeiger auf Namen
		sys	   #26			;PREPARE_SEARCH
		add	   #3,sp
		jmi	   .fehler
		move	   lesepuffer,such_strg

;Headline ausgeben
		move	   #begin,d0
		jsr	   .stringout
		jmi	   .fehler

		add	   #264,#puffer,lesepuffer

;Nchsten Eintrag suchen
.searchread:	push	   such_strg		;Zeiger auf Suchstring
		push	   Quell_fdb		;FDB-Adresse
		sys	   #27			;SEARCH_NEXT
		add	   #2,sp
		jmi	   .endestring

;Verzeichniseintrag laden
		push	   #16			;16 Wrter
		push	   lesepuffer		;Lesepuffer
		push	   Quell_fdb		;FDB-Adresse
		sys	   #13			;READ
		add	   #3,sp
		jmi	   .fehler
		
;Dateinamen zeichenweise ausgeben
		move	   #8,count		;Zhler
		add	   #8,lesepuffer,help		
		cmp	   (help),-		;Eintrag gltig?
		jeq	   .searchread		;Nein, nchsten suchen

.nameout:	bswp	sf (help),-,d0		;High-Byte ausgeben
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler

		and	sf #$ff,(help),d0 	;Low Byte ausgeben
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler

		inc	   help
		dec	sf count		;Schon 16 Bytes ausgegeben?
		jne	   .nameout				

		move	   #32,d0		;Space ausgeben
		jsr	   .out
		jmi	   .fehler

;Dateilnge ausgeben
		add	   #2,lesepuffer,high	;Dateilnge High ermitteln
		add	   -,high,low
		bswp	   -,(high),help	
		or	   help,(low),low	;Dateilnge LOW in Worten ermitteln
		bswp	   (high),-,high		

		clr	   nul
		move	   high,zahl		;Dateilnge high ausgeben
		jsr	   .zahl
		jmi	   .fehler

		move	   low,zahl		;Dateilnge low ausgeben
		jsr	   .zahl
		jmi	   .fehler
		
		move	   #space8,d0		;8 Spaces ausgeben
		jsr	   .stringout
		jmi	   .fehler
		
;WXD Flags ausgeben
		add	   #5,lesepuffer,help	;Zeiger auf Flags
		and	sf #4,(help),-		;Flags ausgeben
		move eq	   #32,d0
		move ne	   #$57,d0		;"W"=Writeprotect
		jsr	   .out
		jmi	   .fehler

		move	   #space3,d0		;3 Spaces ausgeben
		jsr	   .stringout
		jmi	   .fehler

		and	sf #2,(help),-	
		move eq	   #32,d0
		move ne	   #$58,d0		;"X"=Executable
		jsr	   .out
		jmi	   .fehler

		move	   #space3,d0		;3 Spaces ausgeben 
		jsr	   .stringout
		jmi	   .fehler

		and	sf -,(help),-	
		move eq	   #32,d0
		move ne	   #$44,d0		;"D"=Directory
		jsr	   .out
		jmi	   .fehler

		move	   #lf,d0		;Linefeed ausgeben
		jsr	   .stringout
		jmi	   .fehler
		jmp	   .searchread		;nchsten Eintrag suchen


;Zahl-Ausgabe-Routine, wortbezogen und hexadezimal
.zahl:		move	   #4,count
.zahlloop:	rol	   zahl			;4 auszugebende Bits in den unteren Teil des Bytes
		rol	   zahl
		rol	   zahl
		rol	   zahl
		and	   #15,zahl,d0		;Nur 4 Bits betrachten
		cmp	   #10,d0		;Buchstabe oder ZAhl ausgeben?
		add mi	   #$30,d0		;Zahl zwischen 0..9
		sub pl	   #10,d0		;Buchstabe zwischen A..F
		add pl	   #$41,d0
		cmp	   d0,#$30		;Falls Null fhrende Nullen entfernen
		move ne	   -,nul		;Falls <>0 Fhrende Nullen Flag auf False
		jne	   .zahlout
		cmp	   nul,-		;Falls Fhrende Nullen Flag True 0 durch Space ersetzen		
		move eq	   #32,d0
.zahlout:	jsr 	   .out
		rts  mi

		dec	sf count		;4 Ziffern ausgegeben?
		jne	   .zahlloop
		rts

.out:		push	   -			;Zeichen ausgeben
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		rts

;String an StandardOut ausgeben
.stringout:	pushz				;Stringout ausgeben
		push	   d0
		pushz
		sys	   #14
		add	   #3,sp
		rts

;Ende String ausgeben
.endestring:	move	   #endestrg,d0
		jsr	   .stringout
		jmp	   .ende

.fehler:	push	   d0
		sys	   #29			;Fehlerausgabe aufrufen
		inc	   sp
		
.ende:		push	   Quell_fdb
		sys	   #15			;CLOSE, Quellverzeichnis wieder schlieen
		inc	   sp
		rts


cmd:		dw "cmd="
cwd:		dw "cwd="
cwd_zeiger:	dw 0	;Zeiger auf CWD
CmdLine:	dw 0	;Zeiger auf CmdLine
pfad:		dw 0	;Zeiger auf Verzeichnispfad (256 Worte Puffer)
such_strg:	dw 0	;Zeiger auf Suchstring
lesepuffer:	dw 0	;Zeiger auf Suchstring-Puffer (8 Worte)
Quell_fdb:	dw 0	;FDB-Adresse des Verzeichnisses
count:		dw 0	;Zhler
high:		dw 0	;Enthlt Dateilnge in Worten High
low:		dw 0	;Enthlt Dateilnge in WOrten Low
zahl:		dw 0	;Enthlt auszugebende Zahl
nul:		dw 0	;Fhrende Nullen Flag (0=True, 1=False)
help:		dw 0	;Hilfvariable
lf:		dw 13,10,0
endestrg:	dw 13,10,"Ende des Verzeichnisses.",13,10,0
space8:		dw "        ",0
space3:		dw "   ",0
begin:		dw 10,13,"Dateiname        Lnge (hex)    Wrp Exe Dir",13,10
		dw "--------------------------------------------",13,10,0
data 
puffer: 280+128		;Puffer und Stackbereich