include lib
;-----------------------------------------------------------------------------
;FMLL
;-----------------------------------------------------------------------------
;F(or)M(at) L(ow) L(evel) 
format_low:	move	   #warnung,d0	;Wanrstring ausgeben
		jsr	   .stringout
		jmi	   .fehler
		
;Ein Zeichen einlesen, bei "j" oder "J" weiter, sonst Abbruch
.getloop:	push	   -		;Ein Zeichen einlesen, j=ok
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		jmi	   .getloop
		move	   d0,d2

;Zeichen wieder ausgeben
		push	   -
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmi	   .fehler

;ASCII-Code berprfen
		and	   #$ff,d2	;Nur Zeichencode betrachten
		cmp	   d2,#$4a	;J?
		jeq	   .ok		;ja
		cmp	   d2,#$6a	;j?
		rts ne			;auch nicht!, ende

;CmdLine suchen
.ok:		push	   #cmd
		sys	   #10		;SEARCH_ENV
		inc	   sp
		cmp	   (d0),-
		move eq	   #111,d0
		jeq	   .fehler

;Devicedriveradresse bestimmen
		push       d0
		sys        #8		;SEARCHDRIVER
		inc        sp
		jmi        .fehler
		move	   d0,d7

;Arbeitsmeldung ausgeben
		move	   #busy,d0
		jsr	   .stringout
		jmi	   .fehler

;Formatkommando ausgeben
		push       #4		;Job 4:Format
		driver     d7          	;SCSI-Format-Unit
		inc	   sp
		jmi        .fehler

;Erfolgsmeldung ausgeben
		move	   #meldung,d0
		jsr	   .stringout
		rts pl

.fehler:	push	   d0
		sys	   #29		;Fehlerausgabe aufrufen
		inc	   sp
		rts

;String an StandardOut ausgeben
.stringout:	pushz
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts


cmd:		dw "cmd="
busy:		dw 10,13,"Formatiere...",0
meldung:	dw 10,13,"Low-Level-Format erzeugt.",0
warnung:	dw "Alle Daten werden gelscht! Sind Sie sicher? (j/n) ",0
data
stack: 128			;Stackbereich
