PROGRAM Xdisk;

{.......................Declaration...........................}
USES Dos,Crt;

CONST anzahl=21;
      max=anzahl*256-1;

VAR data:     ARRAY[0..max] OF WORD;
    laufwerk: INTEGER;
    f:        FILE;
    s:        STRING; {Filename}
    io:       WORD;
    error:    BOOLEAN;

{......Verwaltungsinformation des Datentrgers erstellen.......}
PROCEDURE Format(vn:STRING);
VAR n:WORD;
BEGIN
    FOR n:=0 TO 18 DO data[n]:=0;
    data[1]:=2;
    data[3]:=16;
    data[4]:=0;
  	data[5]:=1;
    data[6]:=$1111;
    data[7]:=$2222;
    data[16]:=$8765;
    data[17]:=1;
    data[18]:=1;
    data[19]:=0;
    WHILE Length(vn)<16 DO vn:=vn+chr(0);
    FOR n:=0 TO 7 DO data[n+8]:=(ord(vn[2*n+1]) shl 8) + ord(vn[2*n+2]);
    FOR n:=256 TO 511 DO data[n]:=$ffff;
    FOR n:=512 TO max DO data[n]:=0;
    data[513]:=3;
END;


{........Verzeichniseintrag des Programms in Directory erstellen.........}
PROCEDURE Insert;
VAR i,n:WORD;
BEGIN
	  Assign(f,s+'.obj');
    WHILE Length(s)<16 DO s:=s+chr(0);
    FOR n:=0 TO 7 DO data[n+520]:=(ord(s[2*n+1]) shl 8) + ord(s[2*n+2]);
    Reset(f,2);
    io:=IOResult;
    IF io=0 THEN BEGIN
     data[514]:=Filesize(f) div 256;
     data[515]:=Filesize(f) and 255;
     data[516]:=2;
     data[517]:=2;
     FOR n:=1 TO 16 DO data[767+2*n]:=n+3;
     FOR n:=0 TO 16 DO
         FOR i:=1 TO 128 DO data[1023+(256*n)+(2*i)]:=19+n*128+i;
    END ELSE BEGIN
        writeln(' Dateifehler! ');
        writeln(' Dateinamen berprfen und Programm XDISK neustarten!');
    END
END;


{.......Laufwerk und Dateinamen eingeben........}
PROCEDURE Entry;
VAR c:CHAR;
BEGIN
    ClrScr;
    Writeln;
    Writeln;
    Writeln;
    Write(' Welche Kennung hat das Diskettenlaufwerk (3,5")? (A/B)');
    Readln(c);
    IF ((c='a') or (c='A')) THEN laufwerk:=0 ELSE laufwerk:=1;
    Writeln;
    Writeln;
    Write(' Dateinamen ohne Endung eingeben: ');
    Readln(s);
    Writeln;
END;


{.........Verwaltungsinformation und Datei auf Diskette ablegen.........}
PROCEDURE Save;
VAR n,j,cyl,sector,head:   INTEGER;
    i:                     LONGINT;
	  r:                     REGISTERS;
    tmp:                   WORD;
    errorcount:            WORD;

BEGIN
    errorcount:=0;
    error:=FALSE;
    REPEAT
     FOR i:=0 TO max DO data[i]:=(data[i] shl 8) or (data[i] shr 8);
     cyl:=0;
     head:=0;
     sector:=1;
     FOR i:=0 TO 19 DO BEGIN
		     r.ah:=3;
   	 	   r.al:=1;
   	 	   r.ch:=cyl;
	       r.cl:=sector;
    	   r.dh:=head;
    	   r.dl:=laufwerk;
    	   r.es:=Seg(data[256*i]);
  	     r.bx:=Ofs(data[256*i]);
    	   Intr($13,r);
         inc(sector);
         IF sector=19 THEN BEGIN
        	  sector:=1;
        	  Inc(Head); IF Head=2 THEN BEGIN
            	Head:=0;
            	Inc(Cyl);
            END;
         END;
  	 END;
     IF r.ah=0 THEN BEGIN
        FOR i:=0 TO ((FileSize(f) div 256)) DO BEGIN
            IF ((FileSize(f)-(i*256))< 255) THEN j:=((FileSize(f)-i*256)-1) ELSE j:=255;
            FOR n:=0 TO j DO BEGIN
        	      BlockRead(f,tmp,1);
                data[n]:=tmp;
            END;
            r.ah:=3;
   	        r.al:=1;
   	 	      r.ch:=cyl;
	          r.cl:=sector;
    	      r.dh:=head;
    	      r.dl:=laufwerk;
    	      r.es:=Seg(data[0]);
  		      r.bx:=Ofs(data[0]);
    	      Intr($13,r);
            inc(sector);
            IF sector=19 THEN BEGIN
        	  sector:=1;
        	  Inc(Head); IF Head=2 THEN BEGIN
            	         Head:=0;
            	         Inc(Cyl);
                       END;
            END;
  	    END;
     END;
     close(f);
     IF r.ah<>0 then inc(errorcount,1);
    UNTIL ((r.ah=0) or (errorcount=4));
    IF r.ah<>0 THEN error:=TRUE;
END;


{........Hauptprogramm..........}
BEGIN
    Format('XDisk!');
    Entry;
    insert;
    IF io=0 THEN Save;
    IF error=TRUE THEN BEGIN
                  writeln;
                  writeln('Diskettenfehler aufgetreten!');
    END;
END.
