include lib
;-----------------------------------------------------------------------------
;ATRRIB
;-----------------------------------------------------------------------------
attrib:         push       #cmd
		sys        #10          ;CmdLine suchen
		inc        sp
		cmp        (d0),-       ;Dateiname mit angegeben?
		move eq    #111,d0      ;Nein, CmdLine ist leer
		jeq        .fehler

;Dateinamen in CmdLine isolieren
		move       #puffer,d1
.loop:          cmp        (d0),-
		jeq        .flags
		cmp        (d0),#32
		jeq        .flags
		move       (d0),(d1)                                            
		inc        d0
		inc        d1
		jmp        .loop

;Flags nach Dateinamen suchen, Reihenfolg egal
.flags:         clr        (d1)
.loop2:         cmp        (d0),-
		jeq        .open
		cmp        (d0),#$57    ;W?
		or  eq     #4,flags
		cmp        (d0),#$77    ;w?
		or  eq     #4,flags
		cmp        (d0),#$58    ;X?
		or  eq     #2,flags
		cmp        (d0),#$78    ;x?
		or  eq     #2,flags
		cmp        (d0),#$44    ;D?
		or  eq     -,flags
		cmp        (d0),#$64    ;d?
		or  eq     -,flags
		inc        d0
		jmp        .loop2

;Datei ffnen
.open:          push       -
		push       #puffer
		sys        #12          ;OPEN durchfhren
		add        #2,sp
		jmi        .fehler
		move       d0,fdb
		
;Flags setzen
		push       flags
		push       fdb
		sys        #17
		add        #2,sp
		jmi        .fehler

;DAtei schlieen
.ende:          push       fdb
		sys        #15          ;CLOSE          
		inc        sp
		rts

.fehler:        push       d0
		sys        #29          ;Fehlerausgabe aufrufen
		inc        sp
		jmp        .ende

cmd:            dw "cmd="
flags:          dw 0                    ;Dateiflags
fdb:            dw 0                    ;Handle
data
puffer: 256+128                         ;Puffer + Stacktiefe auf 64 Worte festgelegt
