include lib
;-----------------------------------------------------------------------------
;DRVLST
;-----------------------------------------------------------------------------
;DR(i)V(er)L(i)ST gibt alle im System angemeldeten Treiber aus.
drvlst:		move	   27,driverlist	;27:Adresse des Zeigers auf die Treiberliste

;linefeed an StandardOut
		pushz
		push	   #lf
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		jmi	   .fehler

;Namen eines Treibers zeichenweise ausgeben
.loop:		move	   #4,count
		move	   (driverlist),help		
.nameloop:	move	sf (help),d0
		move eq	   #32,d0
		jsr	   .out
		jmi	   .fehler
		inc	   help
		dec	sf count
		jne	   .nameloop

		add	   #4,(driverlist),d0
	
;Block oder Zeichendevice ausgeben
		pushz
		cmp	   (d0),-		;Blockdevice?
		push eq	   #bd
		push ne	   #zd
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		jmi	   .fehler
	
;Zeiger in Treiberliste weiterschalten
		inc	   driverlist
		dec	sf count		;Maximal 32 Treiber sind vorhanden
		jeq	   .ende
		cmp	   (driverlist),-
		jne	   .loop
		rts

;Zeichen ausgeben
.out:		push	   -
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		rts

.fehler:	push	   d0
		sys	   #29			;Fehlerausgabe
		inc	   sp
.ende:		rts

driverlist:	dw 0		;Zeiger in Treiberliste
count:		dw 32		;Zhler fr Treiber
help:		dw 0		;Hilfsvariable
lf:		dw 10,13,0
zd:		dw ": Zeichendevice",13,10,0
bd:		dw ": Blockdevice",13,10,0
data
stack:	64			;Stackbereich