include lib
;-----------------------------------------------------------------------------
;KILL
;-----------------------------------------------------------------------------
;KILL entfernt eine Task aus dem System
kill:		push	   #cmd
		sys	   #10		;CmdLine suchen
		inc	   sp
		move	   d0,CmdLine		
		cmp	   (d0),-	;Falls CmdLine leer -> Fehler
		move eq	   #111,d0
		jeq	   .fehler

;String in Zahl konvertieren
.konvert:	cmp	   (CmdLine),-
		jeq	   .killtask
		move	   (CmdLine),d1

		cmp	   #$30,d1	;Zahl zwischn 0..9?
		jmi	   .zahlfehler
		cmp	   d1,#$39
   		sub pl	   #$30,d1
		jpl	   .zahl

		cmp	   #$41,d1	;Buchstabe zwischen A..F?
		jmi	   .zahlfehler
		cmp	   d1,#$46
		sub pl	   #55,d1
		jpl	   .zahl

		cmp	   #$61,d1	;Buchstabe zwischen a..f?
		jmi	   .zahlfehler
		cmp	   d1,#$66
		sub pl	   #87,d1
		jpl	   .zahl

.zahlfehler:	move	   #111,d0	;Parameterfehler
.fehler:	push	   d0
		sys	   #29		;Fehlerausgabe aufrufen
		inc	   sp
.ende:		rts

;Tasknummer zusammenbauen
.zahl:		asl	   nummer
		asl	   nummer
		asl	   nummer
		asl	   nummer
		add	   d1,nummer
		inc	   CmdLine
		jmp	   .konvert

;Task entfernen
.killtask:	push	   nummer
		sys	   #6		;KILLTASK
		inc	   sp
		jmi	   .fehler

;Erfolgsmeldung ausgeben
		pushz
		push	   #meldung
		pushz
		sys	   #14
		add	   #3,sp
		jmi	   .fehler
		rts

cmd:		dw "cmd="
CmdLine:	dw 0		;Zeiger auf CmdLine
nummer:		dw 0		;Tasknummer
meldung:	dw 13,10,"Task entfernt!",13,10,0
data
stack: 64			;Stackbereich

