include lib
;-----------------------------------------------------------------------------
;REN
;-----------------------------------------------------------------------------
;REN(ame) ndert den Namen einer Datei oder eines Verzeichnisses.
ren:		push	   #cwd		;Cwd suchen
		sys	   #10
		inc	   sp
		move mi	   #111,d0
		jmi	   .fehler
		move	   d0,cwd_zeiger

;CmdLine suchen
		push	   #cmd
		sys	   #10		;SEARCH_ENV
		inc	   sp
		move	   d0,CmdLine
		cmp	   (CmdLine),-	;Ist kein Parameter angegeben?
		move eq	   #111,d0	;Nein, Fehler
		jeq	   .fehler

;Zeiger einstellen
		move	   #puffer,Pfad
		add	   #256,#puffer,lesepuffer

;Pfad des Verzeichnisses bestimmen
		cmp	   (CmdLine),#$2f	;Ist Pfad mit angegeben?
		jeq	   .explizit
.cwd:		cmp	   (cwd_zeiger),-
		move ne    (cwd_zeiger),(pfad)	;Cwd kopieren
		inc  ne	   cwd_zeiger
		inc  ne	   pfad
		jne	   .cwd

.explizit:	cmp	   (CmdLine),-		;Kein neuer Name angegeben?
		move eq	   #111,d0
		jeq	   .fehler
		cmp	   (CmdLine),#32	;" "=Abbruch, an gegebenen Pfad kopieren
		move 	   (CmdLine),(pfad)
		inc  ne	   CmdLine
		inc  ne	   pfad
		jne	   .explizit		
		clr	   (pfad)		;Space lschen
		clr	   (CmdLine)
		move	   CmdLine,CmdPos	;Position fr restauration der CmdLine merken

;Suchstring isolieren
		move	   CmdLine,such_strg
.cut:		cmp	   (pfad),#$2f		;letzten Teil lschen
		clr  	   (pfad)
		dec ne 	   pfad			;pfad:letzte position der Quelle
		dec ne	   such_strg
		jne	   .cut
		inc	   such_strg
		
;Verzeichnis zum Lesen ffnen
		push	   -			;zum lesen+schreiben ffnen
		push	   #puffer		;Dateipfad 
		sys	   #12			;OPEN
		add	   #2,sp,=
		jmi	   .restauriert
		move	   d0,Quell_fdb		;Quell_fdb:FDB-Adresse

;Suchstring vorbereiten
		push	   Quell_fdb
		push	   lesepuffer		;Pufferadresse
		push	   such_strg		;Zeiger auf Namen
		sys	   #26			;PREPARE_SEARCH
		add	   #3,sp,=
.restauriert:	move	   #32,(CmdPos)		;CmdLine Restaurieren
		jmi	   .fehler

;An VerzeichnisPfad an "/" anhngen
		move	   #$2f,(pfad)		;"/" anfgen
		inc	   pfad
		inc        CmdLine
	
		add	   #8,lesepuffer,datei_info	;datei_info:Lesepuffer
.searchread:	add	   #16,lesepuffer,Dateiname	;Dateiname:Zeiger auf Dateinamen

;Abbruchcode (CTRL-C) abfragen
		push	   -		;Ein Zeichen von StIn lesen
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		and	sf #$ff,d0	;Nur ASCII-Code interessiert
		cmp	   d0,#3	;CTRL-C?
		jeq	   .abbruch	;Ja Abbruch

;Nchsten passenden Eintrag suchen
		push	   lesepuffer	;Zeiger auf Suchstring
		push	   Quell_fdb	;FDB-Adresse
		sys	   #27		;SEARCH_NEXT
		add	   #2,sp,=
		jmi	   .ende

;Verzeichniseintrag laden
		push	   #16			;16 Wrter
 		push	   datei_info		;Lesepuffer
		push	   Quell_fdb		;FDB-Adresse 
		sys	   #13			;READ
		add	   #3,sp,=

;gefundenen Namen an Pfad anhngen und lschen
		move	   #8,count		;Zhler
		move	   pfad,d0
.copy:		bswp	   (Dateiname),-,(d0)
		inc	   d0
		and	   #$ff,(Dateiname),(d0)
		inc	   d0
		inc	   Dateiname
		dec	sf count
		jne	   .copy
		clr	   (d0)			;Stringendezeichen anfgen

;alten Dateinamen ausgeben
		move	   #puffer,d0
		jsr	   .stringout
		jmi	   .fehler

;Datei zum Lesen ffnen
		push	   -
		push	   #puffer
		sys	   #12			;OPEN
		add	   #2,sp,=		
		jpl	   .dateiok		
		cmp	   d0,#114		;Writeprotect?
		jne	   .fehler		;Nein anderer Fehler
		move	   #wp_fehler,d0	;Writeprotectfehler ausgeben
		jsr	   .stringout
		jmi	   .fehler
		jmp	   .searchread		

.dateiok:	move	   d0,datei_fdb

;Neuen Namen erzeugen
		move	   pfad,d0
		move	   CmdLine,d1
		move	   -,only_one
		move	   #16,count
.build:		cmp	   (d1),#$2a		;Bei * Abbruch
		clr eq	   only_one		;ES kommen Wildcards vor!, weitere umbenennungen mglich
		jeq	   .weiter
		cmp	   (d1),#$3f
		clr eq	   only_one
		move ne	   (d1),(d0)
		cmp	   (d1),-		;Ende?
		inc ne	   d1
		inc	   d0
		dec	sf count
		jne	   .build

;Datei zum Lesen ffnen um zu testen, ob der Dateiname schon existiert
.weiter:	push	   -
		push	   #puffer
		sys	   #12			;OPEN
		add	   #2,sp
		jpl	   .exist_schon
		cmp	   d0,#109		;Existiert-nicht-Fehler?
		jeq	   .rename		;Ja, Datei umbennenn
		jmp	   .fehler

;Datei exitiert schon, Fehlermeldung ausgeben und Datei wieder schlieen
.exist_schon:	push	   d0
		sys	   #15			;CLOSE
		inc	   sp

;Linefeed ausgeben
		move	   #lf,d0
		jsr	   .stringout
		jmi	   .fehler

;Neuen Dateinamen ausgeben
		move	   #puffer,d0
		jsr	   .stringout
		jmi	   .fehler

;Fehlermeldung ausgeben
		move	   #exist,d0
		jsr	   .stringout
		jmi	   .fehler
		jmp	   .close

;Alles ok, Datei umbenennen
.rename:	push	   datei_fdb
		push	   pfad
		sys	   #20			;RENAME
		add	   #2,sp
		jmi	   .fehler

;String ausgeben
		move	   #meldung,d0
		jsr	   .stringout
		jmi	   .fehler

;Neuen Dateinamen ausgeben
		move	   #puffer,d0
		jsr	   .stringout
		jmi	   .fehler

;Linefeed ausgeben
		move	   #lf,d0
		jsr	   .stringout
		jmi	   .fehler

;Geffnete Datei wieder schlieen
.close:		push	   datei_fdb
		sys	   #15			;Gefundene Datei wieder schlieen
		inc	   sp
		jmi	   .fehler

		cmp	   only_one,-		;Darf noch gesucht werden?
		jeq	   .searchread		;Nchste Datei suchen
		jmp	   .ende		

;String an StandardOut ausgeben
.stringout:	pushz
		push	   d0
		pushz
		sys	   #14			;WRITE
		add	   #3,sp
		rts

;Abbruchmeldung ausgeben
.abbruch:	move	   #break,d0
		jsr	   .stringout
		jmp	   .ende		

.fehler:	push       d0
		sys	   #29			;Fehlerausgabe
		push	   datei_fdb
		sys	   #15			;CLOSE
		add	   #2,sp

.ende:		push	   Quell_fdb
		sys	   #15			;Verzeichnis schlieen
		inc	   sp
		rts

cmd:		dw "cmd="
cwd:		dw "cwd="
cwd_zeiger:	dw 0	;Zeiger auf CWD
CmdLine:	dw 0	;Zeiger auf CmdLine
pfad:		dw 0	;Zeiger auf Dateipfad
such_strg:	dw 0	;Zeiger auf Suchstring
CmdPos:		dw 0	;Zeiger auf Position in der CmdLine, an der etwas verndert wurde
lesepuffer:	dw 0	;Zeiger auf Suchstringpuffer (8 Worte)
datei_info:	dw 0	;Zeiger auf Verzeichniseintrag (16 Worte)
Dateiname:	dw 0	;Zeiger auf Dateinamen im Verzeichniseintrag
quell_fdb:	dw 0	;FDB-Adresse des Verzeichnisses
datei_fdb:	dw 0	;FDB-Adresse der umzubennenden Datei
count:		dw 0	;Zhler
only_one:	dw 0	;Flag, falls mehere Dateien den gleichen Namen bekommen sollen
lf:		dw 13,10,0
meldung:	dw " umbenannt in ",0
wp_fehler:	dw " ist schreibgeschtzt!",13,10,0
exist:		dw " existiert schon!",13,10,0
break: 		dw 13,10,"Befehlsunterbrechung.",13,10,0
data
puffer: 280+128		;Puffer und Stackbereich

