include lib
;-----------------------------------------------------------------------------
;SET
;-----------------------------------------------------------------------------
;SET zeigt den Environmentbereich der aktuellen Task an, setzt und lscht
;Environmentvariablen.
set:		push	   #cmd
		sys	   #10		;CmdLine suchen
		inc	   sp
		move	   d0,d1

;SET-Aufgabe(Anzeigen, Setzen, Lschen) auswerten
loop:		cmp	   (d0),-
		jeq	   show
		cmp	   (d0),#$3d	;"=" ,Abbruch
		inc	   d0
		jne	   loop

		cmp	   (d0),-	;Lschen oder Setzen?
		jeq	   clr

;Env.-Variable zum Setzen in Puffer kopieren
		move	   #puffer,d0
copy:		move	sf (d1),(d0)	
		inc	   d0
		inc	   d1
		jne	   copy

;Environment-Variable setzen
		push	   #puffer	;Setzen
		sys	   #9		;SET_ENV
		inc	   sp
		jmi	   fehler
		rts

;Env.-Bereich anzeigen
show:		add	   #22,akt_task,d2	;Lnge des Env.-Bereiches bestimmen
		sub	   #2,akt_task,d3
		add	   akt_task,(d3),d3
		sub	   #3,d3

loop2:		cmp	   d2,d3
		rts eq
		cmp	   (d2),-
		inc eq	   d2
		cmp	   (d2),-
		rts eq

;Env.-Var. anzeigen
		move	   d2,d0
		jsr	   stringout
		jmi	   fehler

;Linefeed ausgeben
		move	   #lf,d0
		jsr	   stringout
		jmi	   fehler

go_on:		inc	   d2
		cmp	   (d2),-
		jne	   go_on
		jmp	   loop2

;Environment-Variable lschen
clr:		push	   d1
		sys	   #11		;CLR_ENV
		inc	   sp
		rts pl

fehler:		push	   d0
		sys	   #29		;Fehlerausgabe
		inc	   sp
		rts

;String an StandardOut ausgeben
stringout:	pushz
		push	   d0
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		rts

cmd:		dw "cmd="
lf:		dw 10,13,0
data
puffer: 256+64				;Puffer und Stackbereich