include lib
;-----------------------------------------------------------------------------
;TYPE
;-----------------------------------------------------------------------------
;TYPE zeigt den Inhalt einer Datei an
type:		push	   #cmd
		sys	   #10		;CmdLine suchen
		inc	   sp
		cmp	   (d0),-
		move eq	   #111,d0
		jeq	   .fehler
		
;Datei zum Lesen ffnen
		push	   -
		push	   d0		;Zeiger auf Dateinamen
		sys	   #12		;OPEN
		add	   #2,sp
		jmi	   .fehler
		move	   d0,quell_fdb

;Abbruchkommando  (CTRL-C) berprfen
.loop:		push	   -		;EinZeichen von StdIn lesen
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		and	sf #$ff,d0	;Nur ASCII-Code interessiert
		cmp	   d0,#3	;CTRL-C =Abbruch
		jeq	   .abbruch

;16 Worte einlesen
		push	   #16		;16 Zeichen lesen
		push	   #puffer
		push	   quell_fdb
		sys	   #13		;READ
		add	   #3,sp
		jpl	   .ok		
		cmp	   d0,#118	;Kein Zeichen vorrtig?			
		jne 	   .eof_check	;Anderer Fehler!
		cmp	   d1,-		;Kein  Zeichen gelesen?
		jeq	   .loop	;Nein
		jmp	   .ok		;Doch! 
.eof_check:	cmp	   d0,#105	;EOF
		jne	   .fehler	;Anderer Fehler!
		cmp	   d1,-		;Kein Zeichen gelesen?
		jeq	   .eof		;Nein, Ende
		clr 	   eof

;Diese 16 Worte ausgeben
.ok:		push	   d1		;Zeichen an StandardOut ausgeben
		cmp	   -,d1		;Eins?
		push ne	   #puffer	;Nein Adresse bergeben
		push eq	   puffer	;Ja, Zeichen bergeben
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmi	   .fehler
		cmp	   eof,-	;Ist EOF erreicht?
		jne	   .loop	;nein, nchsten Block lesen
		jmp	   .eof

.fehler:	push	   d0		;sonst...
		sys	   #29		;Fehlerausgabe aufrufen
		inc	   sp

.eof:		push	   quell_fdb	;Datei wieder schlieen
		sys	   #15		;CLOSE
		inc	   sp
		rts

;Abruchmeldung ausgeben
.abbruch:	pushz			;String ausgeben
		push	   #break
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmp	   .eof		

cmd:		dw "cmd="
eof:		dw 1			;EOF-Flag
break: 		dw 13,10,"Befehlsunterbrechung.",13,10,0

data
quell_fdb: 1		;FDB-Adresse der Datei
puffer: 16+128		;Puffer und Stackbereich
