include lib
;-----------------------------------------------------------------------------
;TYPEB
;Funktion entspricht dem Dienstprogramm TYPE.
;Unterschied: Es werden jeweils das hherwertige und das niederwertige Byte
;eines Wortes ausgegeben, anstatt nur des hherwertigen.
;-----------------------------------------------------------------------------
;TYPE zeigt den Inhalt einer Datei an
type:		push	   #cmd
		sys	   #10		;CmdLine suchen
		inc	   sp
		cmp	   (d0),-
		move eq	   #111,d0
		jeq	   .fehler
		
;Datei zum Lesen ffnen
		push	   -
		push	   d0		;Zeiger auf Dateinamen
		sys	   #12		;OPEN
		add	   #2,sp
		jmi	   .fehler
		move	   d0,quell_fdb

;Abbruchkommando  (CTRL-C) berprfen
.loop:		push	   -		;EinZeichen von StdIn lesen
		dec	   sp
		pushz
		sys	   #13		;READ
		add	   #3,sp
		and	sf #$ff,d0	;Nur ASCII-Code interessiert
		cmp	   d0,#3	;CTRL-C =Abbruch
		jeq	   .abbruch

;1 Wort einlesen
		push	   -		;1 Wort lesen
		dec	   sp
		push	   quell_fdb
		sys	   #13		;READ
		add	   #3,sp
		jpl	   .ok		

		cmp	   d0,#118	;Kein Zeichen vorrtig?			
		jeq	   .loop
		cmp	   d0,#105	;EOF
		jeq	   .eof		;Nein, Ende

.fehler:	push	   d0		;sonst...
		sys	   #29		;Fehlerausgabe aufrufen
		inc	   sp

.eof:		push	   quell_fdb	;Datei wieder schlieen
		sys	   #15		;CLOSE
		inc	   sp
		rts

;Diese 2 Zeichen ausgeben
.ok:		push	   -		;Zeichen an StandardOut ausgeben
		move	   d0,d7
		bswp	   d0,-,d0
		push 	   d0		;Ja, Zeichen bergeben
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmi	   .fehler
		push	   -		;Zeichen an StandardOut ausgeben
		push 	   d7		;Ja, Zeichen bergeben
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmi	   .fehler
		jmp	   .loop	;nein, nchsten Block lesen


;Abruchmeldung ausgeben
.abbruch:	pushz			;String ausgeben
		push	   #break
		pushz
		sys	   #14		;WRITE
		add	   #3,sp
		jmp	   .eof		

cmd:		dw "cmd="
eof:		dw 1			;EOF-Flag
break: 		dw 13,10,"Befehlsunterbrechung.",13,10,0

data
quell_fdb: 	1		;FDB-Adresse der Datei
stack: 		128		;Stackbereich
