USES Dos,Crt;

CONST anzahl=57;
	  max=anzahl*256-1;

VAR data:ARRAY[0..max] OF WORD;

PROCEDURE Format(vn:STRING);
VAR n:WORD;
BEGIN
	FOR n:=0 TO max DO data[n]:=0;
    data[1]:=2;
    data[4]:=1;
  	data[5]:=1;
    data[6]:=$1111;
    data[7]:=$2222;
    data[16]:=$8765;
    data[17]:=1;
    data[18]:=1;
    data[19]:=0;
    WHILE Length(vn)<16 DO vn:=vn+chr(0);
    FOR n:=0 TO 7 DO data[n+8]:=(ord(vn[2*n+1]) shl 8) + ord(vn[2*n+2]);
    data[256]:=31;
    FOR n:=anzahl TO 4095 DO data[256+n div 16]:=data[256+n div 16] or (1 shl (n and 15));
    data[513]:=3;
    data[515]:=4;
END;

PROCEDURE Save(fn:STRING);
var i,cyl,sector,head:integer;
	r:Registers;
	datei:FILE OF WORD;
begin
    assign(datei,fn);
    rewrite(datei);
    for i:=0 to max do begin
        data[i]:=((data[i] shr 8)+(data[i] shl 8));
        write(datei,data[i]);
    end;
    close(datei);

    cyl:=0;
    head:=0;
    sector:=1;
    FOR i:=0 TO anzahl-1 DO BEGIN
		r.ah:=3;
   	 	r.al:=1;
   	 	r.ch:=cyl;
	    r.cl:=sector;
    	r.dh:=head;
    	r.dl:=0;
    	r.es:=Seg(data[256*i]);
		r.bx:=Ofs(data[256*i]);
    	Intr($13,r);
        inc(sector);
        IF sector=19 THEN BEGIN
        	sector:=1;
        	Inc(Head); IF Head=2 THEN BEGIN
            	Head:=0;
            	Inc(Cyl);
            END;
        END;
  	END;
END;


FUNCTION GetBlock:WORD;
VAR n:WORD;
	found:BOOLEAN;
BEGIN
    found:=FALSE;
    n:=0;
    WHILE not found DO BEGIN
    	IF data[256+n div 16] and (1 shl (n and 15))=0 THEN found:=TRUE ELSE Inc(n);
	END;
    data[256+n div 16]:=data[256+n div 16] or (1 shl (n and 15));
    GetBlock:=n;
	Writeln(n);
END;

PROCEDURE Insert(fn:STRING;typ:WORD);
VAR f:FILE;
	i,n,block,tmp,block2:WORD;
BEGIN
    i:=768+8;
    WHILE data[i]<>0 DO Inc(i,16);
	Assign(f,fn+'.obj');
    WHILE Length(fn)<16 DO fn:=fn+chr(0);
    FOR n:=0 TO 7 DO data[n+i]:=(ord(fn[2*n+1]) shl 8) + ord(fn[2*n+2]);
    Dec(i,8);
    Reset(f,2-typ);
    data[i+2]:=Filesize(f) div 256;
    data[i+3]:=Filesize(f) and 255;
	data[i+5]:=2;
   	block:=GetBlock;
    data[i+1]:=block;
    block:=block*256;

    IF FileSize(f)<=256 THEN BEGIN
    	FOR n:=0 TO FileSize(f)-1 DO BEGIN
        	BlockRead(f,tmp,1);
		    IF typ=0 THEN tmp:=(tmp shl 8) + (tmp shr 8) ELSE tmp:=tmp and 255;
            data[block+n]:=tmp;
        END;
    END ELSE BEGIN
    	data[i+4]:=1;
    	FOR n:=0 TO FileSize(f)-1 DO BEGIN
        	IF n and 255=0 THEN BEGIN
            	block2:=GetBlock;
				data[block+1]:=block2;
                Inc(block,2);
   				block2:=block2*256;
            END;
        	BlockRead(f,tmp,1);
		    IF typ=0 THEN tmp:=(tmp shl 8) + (tmp shr 8) ELSE tmp:=tmp and 255;
            data[block2+(n and 255)]:=tmp;
        END;
    END;
    Close(f);
    if data[3]=$f0 then begin
    		inc(data[2],1);
            data[3]:=0;
    end else
	 Inc(data[3],16);
END;

BEGIN
    ClrScr;
    Format('ROM-Disk!');
    insert('copy',0);
    Save('rd2.obj');
END.
